#ifndef _RELIBC_DIRENT_H
#define _RELIBC_DIRENT_H

#include <sys/types.h>

typedef struct DIR DIR;

typedef struct dirent {
  ino_t d_ino;
  off_t d_off;
  unsigned short d_reclen;
  unsigned char d_type;
  char d_name[256];
} dirent;

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

struct DIR *opendir(const char *path);

int closedir(struct DIR *dir);

int dirfd(struct DIR *dir);

struct dirent *readdir(struct DIR *dir);

long telldir(struct DIR *dir);

void seekdir(struct DIR *dir, long off);

void rewinddir(struct DIR *dir);

int alphasort(const struct dirent **first, const struct dirent **second);

int scandir(const char *dirp,
            struct dirent ***namelist,
            int (*filter)(const struct dirent *_),
            int (*compare)(const struct dirent **_, const struct dirent **_1));

#ifdef __cplusplus
} // extern "C"
#endif // __cplusplus

#endif /* _RELIBC_DIRENT_H */

#include <bits/dirent.h>
